module sltt_const
  !
  != セミラグランジュ法 で用いる定数
  !
  != Constants for Semi-Lagrangian method
  !

  ! 種別型パラメタ
  ! Kind type parameter
  !
  use dc_types, only: DP    ! 倍精度実数型. Double precision.

  ! メッセージ出力
  ! Message output
  !
  use dc_message, only: MessageNotify

  ! 格子点設定
  ! Grid points settings
  !
  use gridset, only:       &
    &                imax, & ! 経度格子点数.
                             ! Number of grid points in longitude
    &                jmax, & ! 緯度格子点数.
                             ! Number of grid points in latitude
    &                kmax    ! 鉛直層数.
                             ! Number of vertical level

  ! 宣言文 ; Declaration statements
  !
  implicit none
  private

  ! 公開手続き
  ! Public procedure
  !
  public :: SLTTConstInit


  ! 公開変数
  ! Public variables
  !
!!$  public :: jew !, dtjw
  public :: dtjw
  public :: iexmin
  public :: iexmax
  public :: jexmins
  public :: jexmaxs
  public :: jexminn
  public :: jexmaxn
  public :: Pix2, PIH
  public :: nloop_dp_h, nloop_dp_v


  !
  ! local variables
  !
  ! Set minimum and maximu indices for south-north separate extended arrays
  !
  integer, save :: iexmin
  integer, save :: iexmax
  integer, save :: jexmins
  integer, save :: jexmaxs
  integer, save :: jexminn
  integer, save :: jexmaxn
  !
  ! jew : latitudinal edge width
  !     : jew >= 4 and dtjw (dtjw is defined below)
  !     : In the current version of implimented semi-Lagrangian scheme, 
  !     : the lower limit of jew is 4, which is restricted by the number of
  !     : latitudinal grids needed to estimate values at poles. 
  !
!!$  integer, parameter         :: jew = 3
  !
  ! dtjw : data transfer latitudinal grid width
!!$  !      : int( C * 2 ) + 3 <= mpjwidth <= jmax and jew
!!$  !      : The mpjwidth must be less than jmax and jew, which is defined 
!!$  !      : above.
!!$  !      : The lower limit of mpjwidth is 3, if the Courant number is
!!$  !      :                      less than 0.5. 
!!$  !      : The lower limit of mpjwidth is 4, if the Courant number is
!!$  !      : greater than 0.5 and less than 1. 
!!$  !      : The lower limit of mpjwidth is 5, if the Courant number is
!!$  !      : greater than 1   and less than 1.5. 
!!$  !      : (But now, if the Courant number is greater than 0.5, this 
!!$  !      : routine would stop in sltt_dp_h and sltt_hiq routines.)
!!$  !
  integer, parameter         :: dtjw = 2

  real(DP), save             :: PIx2, PIH


  integer, save              :: nloop_dp_h = 4
  integer, save              :: nloop_dp_v = 4


  ! 非公開変数
  ! Private variables
  !
  logical, save :: sltt_const_inited = .false.
                              ! 初期設定フラグ.
                              ! Initialization flag



  character(*), parameter:: module_name = 'sltt_const'
                              ! モジュールの名称.
                              ! Module name
  character(*), parameter:: version = &
    & '$Name:  $' // &
    & '$Id: sltt_const.f90,v 1.2 2013/01/27 11:26:14 yot Exp $'
                              ! モジュールのバージョン
                              ! Module version


  !--------------------------------------------------------------------------------------

contains

  !--------------------------------------------------------------------------------------

  subroutine SLTTConstInit

    use gridset    , only : jmax
    use mpi_wrapper, only : nprocs, myrank
    use constants0 , only : PI


    !
    ! local variables
    !

    ! 実行文 ; Executable statement
    !

    if ( sltt_const_inited ) return


    PIx2 = PI + PI
    PIH  = PI / 2.0_DP


!!$    if( jew > jmax/2 ) then
!!$      write( 6, * ) "SLTT ERROR : MYRANK = ", myrank, &
!!$        " JEW = ", jew, " JMAX/2 = ", jmax/2
!!$      write( 6, * ) "SLTT ERROR : JEW MUST BE LESS THAN JMAX."
!!$      stop
!!$    end if
    if( nprocs > 1 ) then
      if( jmax/2 < dtjw ) then
!!$      if( jmax/2 < jew ) then
        write( 6, * ) "SLTT ERROR : MYRANK = ", myrank, &
!!$          " JMAX/2 = ", jmax/2, " TRANSFERED J WIDTH = ", dtjw
          " JMAX/2 = ", jmax/2, " TRANSFERED J WIDTH = ", dtjw
        write( 6, * ) "SLTT ERROR : JMAX MUST BE GREATER THAN TRANSFERED J WIDTH."
        stop
      end if
    end if


    ! Set minimum and maximu indices for south-north separate extended arrays
    iexmin = -2          ! width of halo region of dtjw
    iexmax = imax-1+1+2  ! 1 for 360 longitude and width of halo region of dtjw
    if ( myrank == (nprocs-1) ) then
      jexmins = -dtjw          ! minimum j of southern array
      jexmaxs = jmax/2+dtjw    ! maximum j of southern array
      jexminn = -dtjw+1        ! maximum j of northern array
      jexmaxn = jmax/2+1+dtjw  ! maximum j of northern array
    else
      jexmins = -dtjw+1        ! minimum j of southern array
      jexmaxs = jmax/2+dtjw    ! maximum j of southern array
      jexminn = -dtjw+1        ! maximum j of northern array
      jexmaxn = jmax/2+dtjw    ! maximum j of northern array
    end if


    sltt_const_inited = .true.

  end subroutine SLTTConstInit

  !--------------------------------------------------------------------------------------

end module sltt_const
